#pragma once
//#include <common_audio\wav_file.h>
#include "VoIPController.h"
#include <queue>


#ifndef TGVOIP_USE_CALLBACK_AUDIO_IO
#define TGVOIP_USE_CALLBACK_AUDIO_IO
#endif


#define AUDIO_STATE_NONE -1
#define AUDIO_STATE_CREATED 0
#define AUDIO_STATE_CONFIGURED 1
#define AUDIO_STATE_RUNNING 2

#define CALL_STATE_NONE -1
#define CALL_STATE_REQUESTED 0
#define CALL_STATE_INCOMING 1
#define CALL_STATE_ACCEPTED 2
#define CALL_STATE_CONFIRMED 3
#define CALL_STATE_READY 4
#define CALL_STATE_ENDED 5

using namespace tgvoip;
using namespace tgvoip::audio;

namespace tgvoip
{
	namespace audio
	{
		class AudioInputModule;
		class AudioOutputModule;
	}
}



namespace VoIPNamespace
{
	class VoIP
	{
	public:


		void initVoIPController();
		//void initConfig();
		void SetEncryptionKey(char* key, bool isOutgoing);
		
		void deinitVoIPController();
		std::string GetDebugString();
		std::string GetDebugLog();
		void unsetOutputFile();
		void unsetInputFile();
		void setOutputFile(const char* filename);
		void setInputFile(const char* filename);
		void setConfigFile(const char* filename, const char* logfile);
		void setLogFile(const wchar_t* logfile);
		void SetRemoteEndpoints(vector<Endpoint> endpoints, bool allow_p2p, int max_layer);
		void Start();
		void Connect();

		void recvAudioFrame(int16_t* data, size_t size);
		void sendAudioFrame(int16_t* data, size_t size);
		bool playing = false;
		int state = STATE_WAIT_INIT;
		//webrtc::WavReader* wavReader;
		//webrtc::WavWriter* wavWriter;

	private:
		std::queue<FILE*> inputFiles;
		std::queue<FILE*> holdFiles;
		Mutex inputMutex;

		FILE* inputFile;
		FILE* outputFile;
		Mutex outputMutex;

		size_t readInput;
		size_t readOutput;
		int callState = CALL_STATE_NONE;
		VoIPController* inst;
	};
}
